Summary

Generated value of token can be predictable

Who should read this

All Struts 2 developers and users

Impact of vulnerability

The attacker make a specially craft form using the predicted token that force an action to a logged-in user (CSRF).

Maximum security rating

Medium

Recommendation

Developers should immediately upgrade to Struts 2.3.20 if they use <s:token/> support

Affected Software

Struts 2.0.0 - Struts 2.3.16.3

Reporter

Philippe Arteau of Groupe Technologies Desjardins

CVE Identifier

CVE-2014-7809

Problem

The attacker fetch any given form where a token is present and can predict the next value of the token used to secure form submission.

Solution

In Struts 2.3.20 a better random generator was used to generate unpredictable values.

Backward compatibility

No backward compatibility problems are expected.

Workaround

Not possible when usingĀ <s:token/> tag - you must upgrade to the latest version.